
repeat_transpose_pu    = 1
pattern_repeat_tb    = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
pattern_transpose_tb = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}          
  
local arp_tb = {}

local vb = renoise.ViewBuilder()

function fillRestoreAll ()
  local note_col = MW.phr.col
  
  if MW.phr.editor_poly then
    for i=12,1,-1 do           
      assignNoteTbs(i)     
      fill(i)  
    end 
  else
    fill(note_col) 
  end 
end


local function repeatSeqCol(note_col) 
  local pat_con = getPatFun(MW.block_editing)
  
  local pat, pat2,note, add
    
  if pat_con then
  
    local mul = 1

    for i=1,UI.rpn_vb.value do
      for line=1,UI.rplen_vb.value do       
        
        pat = pat_con(line, note_col)
        
        note = pat.note_value 
        add = UI.rplen_vb.value * mul
        
        pat2 = pat_con(line+add, note_col)
        pat2.note_value = 121
        pat2.instrument_value = 255
        pat2.volume_value = 255

             
        if note < 119 then
          local note12, oct = oct0 (note)
          
          local n = 1
          if pattern_repeat_tb[i] < 0 then
            n = -1
          end
            
          for j=1,math.abs(pattern_repeat_tb[i]) do  
            note12,oct = transpose(n, note12 ,oct)           
          end
          
          note = oct*12 + note12
                  
          if note < 0  then 
            note  = 0
          elseif note > 119 then
            note = 119
          end  
 
          pat2.note_value = note
          pat2.instrument_value = pat.instrument_value
          pat2.volume_value = pat.volume_value           
        end  
      end
      mul = mul + 1
    end 
  end
end

function repeatSeq()
  if MW.phr.editor_poly or MW.phr.editor_chords then
    for i=12,1,-1 do 
      repeatSeqCol(i)  
    end    
  else
    repeatSeqCol(MW.phr.col)
  end
end


local function rpLine(line)
  if repeat_transpose_pu == 1 then return false end
  
  for i=1,UI.rpn_vb.value do
    if i==1 and line > 0 and line <= i * UI.rplen_vb.value then
      return pattern_transpose_tb[i]
    elseif i>1 and line > (i-1) * UI.rplen_vb.value and line <= i * UI.rplen_vb.value then 
      return pattern_transpose_tb[i]  
    end  
  end
  return false
end
 

function make_vb(ix)  
  UI.repeat_tr_vb[ix] = vb:valuebox {
      tooltip = "Transpose amount",
      min = -24,
      max = 24,
      value = pattern_repeat_tb[ix],
      width = 50,
      notifier = function(value) 
        pattern_repeat_tb[ix] = value 
        if repeat_transpose_pu == 2 or repeat_transpose_pu == 3  then
          fillRestoreAll()
        end
                   
        repeatSeq()
      end
    }
  return UI.repeat_tr_vb[ix]
end  

function make_vb_tr(ix)  
  UI.repeat_tr_vb[ix] = vb:valuebox {
      tooltip = "Transpose amount",
      min = -24,
      max = 24,
      value = pattern_transpose_tb[ix],
      width = 50,
      notifier = function(value) 
        pattern_transpose_tb[ix] = value 
        
        local note_col = MW.phr.col
        if MW.phr.editor_poly then    
            
          for i=12,1,-1 do           
            assignNoteTbs(i)                        
            trNOrep(val,i)        
            fill(i)
          end
        else    
          fill(note_col)
        end
      end
    }
  return UI.repeat_tr_vb[ix]
end    



local function lastLen (ptr, st)
  local res = true
  
  for i=st,#ptr.len do
    if ptr.len[i] > 0 then 
      return false
     end
  end
  
  return res 
end

function fillVel(note_col,ptr,st)
  
  local line = 0   
  
  local pat_con, pat_len, line2, pat = getPatFun(MW.block_editing)
     
  if MW.block_editing then line = line2  end  
  
  for i=1,st do
    line = line +  ptr.len[i] 
  end
           
  if line > pat_len then return end
    
  if MW.phr.editor_name == "Chords" or MW.phr.editor_name == "Tonnetz" then 
    local tb = Chords.forms[UI.chord_forms[st]]       
        
    for n=1,#tb do          
      pat = pat_con(line, n)
      pat.volume_value = ptr.vel[st]   
    end          
  else
    pat = pat_con(line, note_col)
    pat.volume_value = ptr.vel[st]          
  end
end

function fill(note_col, ...)  
  if MW.phr.editor_chords then 
    fillPtr(note_col, CHptr, MW.phr.event_type, ...)
  else 
    fillPtr(note_col, Nptr, MW.phr.event_type, ...)  
  end
end

function fillPtrFX(ptr) 

  local tr       = renoise.song().selected_track_index  
  local pattern  = curPattern()    
  local all_cols = {1,2,3,4,5,6,7,8}
    
  for pat,ln,col,tr,sel in patternMW(all_cols,'pat_fx',MW.block_editing,pattern) do    
    pat.number_value = 0 
  end
  
  if not ptr.fx or #ptr.fx == 0 then return end  
  
  local phr_len  = renoise.song().selected_pattern.number_of_lines  
  
  for _,v in ipairs(ptr.fx) do
    if v > phr_len then return end
    pattern.tracks[tr].lines[v]:effect_column(1).number_value = 17      
  end  
end


function fillPtr(note_col, ptr, event_type, ...) 

  if UI.suspend_update then return end   

  if MW.phr.editor_poly and note_col == 1 then 
    fillPtrFX(ptr)
  elseif not MW.phr.editor_poly then
    fillPtrFX(ptr) 
  end
  
  local o     = {} 
  o.st        = 1
  o.en        = #ptr.len
  o.pos       = false
  o.line      = 0   
  o.inst      = renoise.song().selected_instrument_index - 1 
  o.clear     = 'col'    
  o.track     = renoise.song().selected_track_index  
  o.add_off   = false 
  o.line_off  = nil
  o.fill_chrd = true
  
    
  local st2,en2
  
  if  MW.editor_vb or MW.phr.editor_chords then
    o.pos = true  
  end
  
  if event_type == 3 then
    o.clear = 'all'
  end  
  
  
  if arg[1] then   
    for k,v in pairs(arg[1]) do 
      o[k] = v
    end
  
    if arg[1].st then    
      if o.st > 1 then 
        for i=1,o.st-1 do
          o.line = o.line +  ptr.len[i] 
        end
      end
    end
  end 
  
  local pat    
  local pat_con, pat_len, sel_start = getPatFun(MW.block_editing, renoise.song().selected_pattern_index, o.track) 
  
  if o.pat_len then pat_len = o.pat_len end 
   
--  if MW.block_editing then o.line = sel_start  end   
  
  local en3      = pat_len  ------------- clear 
  local line_clr = o.line       
  
  
  if MW.block_editing then
    line_clr  = sel_start
    sel_start = sel_start + 1      
  end
    
  if o.st == o.en and o.st < #ptr.len then    
  
    line_clr = 0
    for i=1,o.st do
      line_clr = line_clr +  ptr.len[i]
    end
    
    if o.st < #ptr.len and not lastLen(ptr, o.st+1) then   -- if not last note
      en3 = line_clr + ptr.len[o.st+1] - 1
    else  
      en3 = pat_len   -- if last note clear the rest of track
    end
  end     -- print('clear line ' .. line_clr .. '  en3 ' .. en3 .. '  st ' .. o.st .. '   en ' .. o.en ..  '   clear ' .. o.clear)  
  
  
  if arg[1] then 
    if arg[1].clr_line then
      line_clr = arg[1].clr_line
    end
    
    if arg[1].clr_end then
      en3 = arg[1].clr_end
    end
  end

  if o.clear == 'all' then       
    for j=1,12 do 
      for i=line_clr+1,en3 do  
        pat                    = pat_con(i, j)
        pat.note_value         = 121
        pat.volume_string      = ""
        pat.instrument_string  = ""        
      end   
    end 
  elseif o.clear == 'col' then 
    for i=line_clr+1,en3 do  
      pat                    = pat_con(i, note_col)
      pat.note_value         = 121
      pat.volume_string      = ""
      pat.instrument_string  = ""      
    end
  end    

  if o.line_off then 
    pat            = pat_con(o.line_off, note_col) 
    pat.note_value = 120
  end
  
  
  if MW.phr.editor_name == "Arpeggiator" then
    Arp.player_pos = fillTb (pat_len,nil) 
  end
    
  local last_note_line = 0  
  local last_note_ix = 0  
  
  local sums = {}   
  
  for i=o.st,o.en do   
    o.line = o.line +  ptr.len[i]    --print('o.line ' .. o.line .. ' i ' .. i .. '  sel_start ' .. sel_start .. '  pat_len ' .. pat_len)
    
    if o.line ~= last_note_line then
      table.insert(sums, {ix = i, line = o.line}) 
    end
    
    if o.line > pat_len then break end
    
    last_note_line = o.line
  
    local not_empty_note = true
    if event_type == 3 then
      if ptr.notes[i] == nil then
        not_empty_note = false     
      end
    else
      if ptr.note[i] == nil then
        not_empty_note = false     
      end  
    end    
        
    if ptr.len[i] > 0 and not_empty_note and o.line >=  sel_start then   
      
      if o.st == o.en and false then  ---------------- delete
        if i < #ptr.len then  -- clear pattern
          st2 = o.line
          en2 = ptr.len[i+1]-1
        else
          st2 = o.line
          en2 = pat_len    
        end 
      
        for ln=st2,en2 do         
          for ncol=1,12 do
            pat                    = pat_con(ln, ncol)
            pat.note_value         = 121
            pat.volume_string      = ""
            pat.instrument_string  = ""
          end   
        end  
      end    
                      
      last_note_ix = i  
 
      if o.fill_chrd and event_type == 3 then
         
        local ch_notes = ptr.notes[i]
        
        local rptr = rpLine(o.line)          
        if rptr and rptr ~= 0 then  
        
          for k,ch_note in ipairs(ch_notes) do
          
            local nn,oct = oct0(ch_note)              
            nn,oct = transpose (rptr, nn, oct)
            ch_notes[k] = nn + oct*12
          end   
        end   
        
        if MW.phr.editor_name == "Arpeggiator" then  ---------------------------
          local arpChrd = tbOct0(ch_notes) 
          
          --table.sort(arpChrd)
          
          local pos = ptr.arp.off[i] 
          if pos > #arpChrd then
            pos = #arpChrd
          end

          local chrd_main_note = ch_notes[pos]   
           
          local arpChrdAll = {}
          for j=0,9 do
            for i=1,#arpChrd do
              table.insert(arpChrdAll, arpChrd[i] + j * 12)
            end
          end   
          
          local arp_ix = retIx (arpChrdAll,chrd_main_note)
               
          local arp_en
         
          if i+1 > #ptr.len then
            arp_en =  pat_len
          else  
            local next_len = nextLen(i+1,ptr.len)
            if next_len == 0 then
              arp_en = pat_len  
            else 
               arp_en =  o.line + next_len   
            end
          end
          
          local n = 1
          local mul = 1
          local arp_ix2 = arp_ix
          local arp_form = Arp.forms [ptr.arp.form[i]] 

          for arp_line = o.line, arp_en, Arp.step do 

            local patArp = pat_con(arp_line, note_col)
            
            Arp.player_pos [arp_line + Arp.step] = {arp_n = n,arp_form = ptr.arp.form[i]}
            
            if arp_tb[i] == nil then
              arp_tb[i] = {}  
            end
             
            if arp_tb[i][note_col] == nil then
              arp_tb[i][note_col] = {}
            end
            
            if not ptr.arp.form[i] then
              patArp.note_value = arp_tb[i][note_col][arp_line]
            
              if patArp.note_value < 121 then    
                patArp.instrument_value = o.inst 
              end
            elseif Arp.skip_note_tb[ptr.arp.form[i]][n] then
              patArp.note_value = 121
              patArp.instrument_string  = ""
              patArp.volume_string  = ""              
              
              arp_tb[i][note_col][arp_line] = 121               
            else
              local nA, oA = oct0(arpChrdAll[arp_ix2])
              
              local note = noteInScale (nA) + oA*12
              
              patArp.note_value = note
              patArp.volume_value = ptr.vel[i]             
              patArp.instrument_value = o.inst
              arp_ix2 = arp_ix2 + arp_form[n]
              
              arp_tb[i][note_col][arp_line] = note
            end                       
           
            if arp_ix2 > #arpChrdAll or arp_ix2 == 0 then
              arp_ix2 = arp_ix 
            end 

            if arpChrdAll[arp_ix2] >  arpChrdAll[arp_ix] + 12*ptr.arp.oct[i] or arpChrdAll[arp_ix2] > 120 then
              arp_ix2 = arp_ix
            elseif arpChrdAll[arp_ix2] <  arpChrdAll[arp_ix] - 12*ptr.arp.oct[i] or arpChrdAll[arp_ix2] < 0 then
              arp_ix2 = arp_ix  
            end
            
            if #arp_form > 1 then           
              n = n + mul       
              if n > #arp_form then 
                if  Arp.directions[ptr.arp.form[i]] == 1 then
                  n = 1
                  mul = 1
                else
                  mul = -1   
                  n = #arp_form-1
                end 
              elseif Arp.directions[ptr.arp.form[i]] == 2 and n < 1 then
                mul = 1
                n = 2 
              end
            end
               
          end  
        else ------------------------ chord ---------------------------------
          
          local patChrd
          
          for n=1,12 do
            patChrd = pat_con(o.line, n)  
            
            patChrd.note_value       = 120
            patChrd.volume_value     = 255
            patChrd.instrument_value = 255            
          end


          for n=1,#ch_notes do 
            patChrd = pat_con(o.line, n)
            
            patChrd.note_value       = clamp(noteInScale(ch_notes[n]),0,119)            
            patChrd.volume_value     = ptr.vel[i]               
            patChrd.instrument_value = o.inst 
          end
        end  

      else  --------- notes

        local rptr     = rpLine(o.line)     
        local note,oct = ptr.note[i], ptr.oct[i]  
       
        if rptr and rptr ~= 0 then        
          note,oct = transpose (rptr, note, oct) 
        else
          note = noteInScale(note)   
        end
   
        note = note + oct * 12         

        pat = pat_con(o.line, note_col)  
        pat.note_value = clamp(note,0,119)
        pat.volume_value = ptr.vel[i]       
        
        if MW.edit_RN_phrase == false then
          pat.instrument_value = o.inst
        end
      end      
      
      local ln_off = o.line + ptr.off[i]
      
      local k=i+1      
      
      if ptr.off[i] > 0 and ln_off < pat_len then
        for j=i+1,#ptr.len do 
          if ptr.len[j] > 0 then
            k = j  
            break
          end 
        end
        
        if event_type == 3 then
          for n=1,#ptr.notes[i] do   
          
            pat = pat_con(ln_off, note_col+n-1)
                    
            if i < #ptr.len and ln_off < o.line + ptr.len[k] then      
              pat.note_value = 120
            elseif i == #ptr.len then           
              pat.note_value = 120
            end 
          end
        else
          pat = pat_con(ln_off, note_col)
          
          if i < #ptr.len and ln_off < o.line + ptr.len[k] then          
            pat.note_value = 120    
          elseif i == #ptr.len then           
            pat.note_value = 120  
          end  
        end              
      end
    end    
  end  

  if last_note_ix > 0 then  
  
    -- make sure it's the last note  
    if last_note_ix == #ptr.len or lastLen(ptr, last_note_ix+1) or last_note_line + ptr.len[last_note_ix+1] > pat_len then 
   
      local note_off_last = ptr.off [last_note_ix] 
      
      if last_note_line + note_off_last <= pat_len then
        if event_type == 3 then
          if last_note_ix > 0 and note_off_last > 0 then
            for n=1,#Chords.forms [UI.chord_forms[last_note_ix]] do      
              pat = pat_con(last_note_line + note_off_last, note_col+n-1)
              pat.note_value = 120  
            end
          end
        else
          if last_note_ix > 0 and note_off_last  > 0 then 
            pat = pat_con(last_note_line + note_off_last, note_col)
            pat.note_value = 120 
          end
        end
      end
    end
  end 
  
  
  if o.add_off then  
    if o.st > 1 and ptr.off[o.st-1] > 0 then  
      local ln = 0
      for i=1,o.st-1 do
        ln = ln + ptr.len[i]
      end  
       
      if ln + ptr.off[o.st-1]  < ln + ptr.len[o.st] then
        ln = ln + ptr.off[o.st-1]     

          local len = note_col
          if event_type == 3 then len = #ptr.notes + note_col-1 end  
           
          for nc=note_col,len do 
            pat = pat_con(ln, nc)
            pat.note_value = 120
            pat.instrument_value = 255 
          end
      end
    end   
  end
      
      
  o.line = sel_start
  local last_i, i = 0,1
  while o.line < pat_len and i <= #ptr.len do 
    o.line = o.line +  ptr.len[i]    
    
    if  ptr.len[i] > 0 then
      last_i = last_i + 1
    end       
    i=i+1
  end  
  
  
  if o.pos and #sums > 0 then       
    local len, el, tb      
    
    MW.timer_pos = {} 
    if #sums > 1 then
      for i=2,#sums do  
        el  = sums[i-1].ix
        len = sums[i].line - sums[i-1].line        
  
        tb = createFillTb(len, el)
        tableConcat(MW.timer_pos, tb)   
      end
    end
    el  = sums[#sums].ix
    len = pat_len - sums[#sums].line
 
    tb     = createFillTb(len, el)
    tableConcat(MW.timer_pos, tb) 
  end   
  
  return #sums > 0   
end


function setFillPoly(fil)
  assignPolyTbs()          
  
  if emptyPoly() then
    sprint('Poly of phrase slot ' .. MW.phr.no .. ' is empty') 
  elseif fil then 
    sprint('')
    for i=1,12 do        
      local oct_lowest, oct_highest = 8,2
            
      assignNoteTbs(i) 
            
      if Nptr.oct_lowest < oct_lowest then
        oct_lowest = Nptr.oct_lowest
      end
      
      if Nptr.oct_highest > oct_highest then
        oct_highest = Nptr.oct_highest
      end
      
      UI.suspend_update = true      
      UI.oct_st.value  = oct_lowest  
      UI.oct_end.value = oct_highest+1  
      UI.suspend_update = false
      
      if MW.phr.col ~= i then              
        fill(i)
      end
    end
    
    assignNoteTbs(MW.phr.col)      
    fill(MW.phr.col)
  end
end

function setFillChords(fil) 
  assignChordTbs()      
 
  if noteLengthEmpty(CHptr.len) then
    sprint('Chords in phrase slot ' .. MW.phr.no .. '  are empty')           
  elseif fil then   
    local col = MW.phr.col
    
    UI.oct_st.value  = CHptr.oct_lowest
    UI.oct_end.value = CHptr.oct_highest+1
    
    if MW.harmonize_typ == 1 then 
      fill(col)        
    end
    getChordPos(CHptr.len)
  end    
end  

function setFillMono(fil)
  local col = MW.phr.col  
  assignNoteTbs(col)      
 
  if noteLengthEmpty(Nptr.len) then
    sprint('Note column of phrase slot ' .. MW.phr.no .. ' is empty')                
  elseif fil then
    UI.oct_st.value  = Nptr.oct_lowest
    UI.oct_end.value = Nptr.oct_highest+1    
    
    if MW.harmonize_typ == 2 then 
      harmonizeP2Ch ()  
    end
    fill(col) 
  end    
end     
    