
---preferences -----------------------------------------------------------------------------

preferences = renoise.Document.create("MouseWarriorPrefs") {
  path = "c:\\audio\\Seqs2\\"  
 }
 
renoise.tool().preferences = preferences
-----------------------------------------------------------------------------------------

local vb = renoise.ViewBuilder()

require ('lambda')
require ('process_slicer')

require ('globals')
require ('helpers')
require ('utilities')
require ('inout')
require ('init')
require ('notes ops')
require ('fill_rptr')
require ('grab')
require ('chord_tb')
require ('chord_tb_sk')
require ('timer')
require ('editors')
require ('harmonization')
require ('markov')
require ('randomization')

require ('ui_setup')
require ('ui_save')
require ('ui_grab')
require ('ui_seq')
require ('ui_note_col_oct')
require ('ui_editor')
require ('ui_lib')
require ('ui_tr')
require ('ui_harmonize')
require ('scan')
require ('ui_scales')
require ('ui_arp')
require ('ui_menu')
require ('ui_rp_tr')


MW.path = preferences.path.value
          
for i=1,#Scales.names do
  Scales.names2[i] = Scales.names[i]
  
  if (i > 1) then
    Scales.names2[i-1] = Scales.names[i]
  end
end

       
Chords.forms_to_str = formStr(Chords.forms)
table.insert(Chords.forms_to_str,'other')
table.insert(Chords.forms,{1})
--Chords.forms_to_str2 = copy(Chords.forms_to_str)


Scales.forms = addToTb (Scales.forms,-1)
Arp.directions = fillTb (#Arp.forms,1)  

Chords.forms = addToTb (Chords.forms,-1)

--buildChordTable0()
--buildChordTable()
--buildChordTable0SK()
--buildFormCS()

--local fn = MW.path .. 'chord_tb.lua'  
--if (fileExists(fn)) then
--  sprint('Found chords lookup table ' .. fn)
--  dofile (fn) 
--else
--  sprint('Generating chord lookup table')
--  buildChordTable()
--end



fn = MW.path .. 'scan_sk.lua'  
if (fileExists(fn)) then  
  sprint('Found scale & key scans ' .. fn)
  dofile (fn) 
end 

fn = MW.path .. 'scan_recomb.lua'  
if (fileExists(fn)) then
  sprint('Found combinator scans ' .. fn)
  dofile (fn) 
end 

fn = MW.path .. 'scan_motifs.lua'  
if (fileExists(fn)) then
  sprint('Found motif scans ' .. fn)
  dofile (fn) 
end 

fn = MW.path .. 'chord_tb_cs.lua'  
if (fileExists(fn)) then
  sprint('Found form cs scans ' .. fn)
  dofile (fn) 
end 

initNotes()
initChords() 
initTonnetzFormsMtb()
 
------------------------------------------------------- GUI

UI.dialog_content2 = vb:column {
    margin = 5,
    spacing = 6,
  } 
  
local function show()    
  
  if (io.exists(MW.path)) then
    Scan.files = getFilesRemExt()
    getArpFiles()
  else
    SetupPrompt()
    return
  end
     
   if (UI.dialog and UI.dialog.visible) then  
     UI.dialog:show()  
     return 
  end
  
  local TEXT_ROW_WIDTH = 80

  local setup_but = vb:button {
      tooltip = "Setup",
      text = " ! ",
      notifier =  function ()
        SetupPrompt()
      end 
    }             
  
  UI.dialog_content =     
    vb:column {  
      margin = 5,
      spacing = 3,
      
      vb:row {
        spacing = 7,   
        
        ui_grab(),        
        ui_seq_row(),     
        ui_note_col_oct(), 
        ui_transpose(),         
      },    
      
      vb:row {
        spacing = 7,      
        ui_editor_row(),                     
        ui_library(),             
        ui_harmonize(),  
                            
      },             
   
      vb:row{
        spacing = 7,
        
        ui_scales(),
        ui_randomize(),
        ui_rptr(),
      },     
      
      ui_arp(),
      UI.editor_main,  
    }
   
  local pattern = curPattern ()
  local tr = renoise.song().selected_track_index  
  
  if (#pattern:track(tr).lines[1].note_columns > 0) then
    updateSlots()
    --for i=MW.seq_start,MW.seq_length do
    --  UI.editor_main:add_child(editorRows(i)) 
    --end
  end       
    
  UI.dialog = renoise.app():show_custom_dialog( "Mouse Warrior", UI.dialog_content, function(dialog,key) return key end)

  if not(renoise.tool():has_timer(MW.timerFun)) then
    renoise.tool():add_timer (MW.timerFun, MW.timer)
  end 
 
  MW.started = true
end
  


---------- menu -------------------------------------------
  
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Mouse Warrior",
  invoke = show
}

renoise.tool():add_keybinding{
  name = "Pattern Editor:Tools:MouseWarrior..." , 
  invoke = show}

------ keybindings  ------------------------------------------

renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Transpose Scale Up..." , 
  invoke = function () 
    transposeBlock(1)                                       
  end}

renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Transpose Scale Down..." , 
  invoke = function () 
    transposeBlock(-1)                                       
  end}  
  
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Block + Form Form..." , 
  invoke = function () 
    blockLineSetForm(1)                                      
  end}    

renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Block - Form Form..." , 
  invoke = function () 
    blockLineSetForm(-1)                                      
  end}      
  
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Block capture chord..." , 
  invoke = function () 
    captureFirstChordFromBlock()                                      
  end}   
  
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW restore captured notes..." , 
  invoke = function () 
    restoreCapturedBlockNotes()                                      
  end} 
    
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW grab notes..." , 
  invoke = function () 
    if MW.started then
      grabNotes()     
    end                                   
  end}   
    
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Tonnetz R1..." , 
  invoke = function () 
    if Chords.captured_slot then
      Tonnetz.random1(Chords.captured_slot)                               
    end
  end}  
  
renoise.tool():add_keybinding{
  name = "Pattern Editor:Block Operations:MW Tonnetz R2..." , 
  invoke = function () 
    if Chords.captured_slot then
      local ix = Chords.captured_slot 
      UI.chrd_form_tz_vbs[ix].value = math.random(1,11)                           
    end
  end}   