
class 'Markov'

  Markov.buf       = {}
  Markov.event     = {}  
  Markov.chain     = {}
  Markov.chain2    = {} 
  Markov.rootnotes = {} 
  
  Markov.poly_ev      = {}
  Markov.poly_dur     = nil  
  Markov.poly_len     = {1,1,1,1,1,1,1,1,1,1,1,1}  
  Markov.poly_add     = {0,0,0,0,0,0,0,0,0,0,0,0}
  Markov.poly_durs    = {0,0,0,0,0,0,0,0,0,0,0,0}   
  Markov.poly_sub_len = {0,0,0,0,0,0,0,0,0,0,0,0}   
  
  Markov.ns = {}
  Markov.last_ns = ''
  
  Markov.PST_l = 3
  Markov.order = 1
  Markov.PST_minp = .15
  Markov.PST_r = 1
  Markov.IP_iter = 0
  Markov.IP_max_depth = 16
  
  Markov.continue = 1
  Markov.mul = false
  Markov.first_n_ix = nil
  
  Markov.params = ''
  Markov.typ = ''
  
  Markov.i = {}
  
local function getLenRow(len_tb)
  local line = 0  
  
  local last_ln = 0
  local last_k = 0
  
  for k,v in ipairs(len_tb) do
     
    if v > 0 then  
      line = line + v
      last_k = k
    end    
  end
  return last_k+1,line 
end


function Markov:paramsToStr()  
  local tb    
  
  if self.typ == 'IP' then      
    tb = {
       self.typ,
       self.order,
       self.IP_iter,
       self.IP_max_depth      
    }    
    return table.concat(tb,'_')
  else        
    local mul
    
    if self.mul then 
      mul = 't'
    else
      mul = 'f'
    end
    
    tb = {
       self.typ,
       self.order,
       mul,
       self.PST_l,
       self.PST_minp,
       self.PST_r
    }    
    return table.concat(tb,'_')
  end
end


--function Markov:grabNotes(init)  
--  return
--end


function Markov:grabNotes(init)  ---------del
  
  local ph  = MW.phr.no
  local col = MW.phr.col
  
  local pat_len = renoise.song().selected_pattern.number_of_lines
  
  if self.event_type == 2 then
    
   -- initPoly() -- if init then initPoly() end
    
    for i=12,1,-1 do  
      if init then POLYptr[i] = Notes.new(pat_len) end
            
      GrebSeq(i,false, MW.phr[ph].notes[ph])  
     end         
  elseif self.event_type == 3 then
    if init then CHptr = Chords.new(pat_len) end
    
    GrebSeq(col, true, CHptr) 
  else 
    if init then Nptr = Notes.new(pat_len) end

     GrebSeq(col, false, Nptr)  
  end
end


function getKeys(tb) ----------------------------------------------- Branches ---------------------------
  local keys = {}
  
  for k,v in pairs(tb) do 
    if type(v) == "table"  then
      table.insert(keys,k)
    end 
  end   
  return keys
end


function getRandBranch (tb, res_tb, last_branch, last_branch_key, first_key)   -- (tb,{},{},nil,nil)

  local keys = getKeys(tb)
  local rn
  
  local key, node = nil,nil
  
  if #keys > 0 then 
    rn = math.random(#keys)
    key = keys[rn]
    
    if first_key == nil then
      first_key = key
      
      last_branch = tb
    end            
    
    if #keys > 1 then
      last_branch_key = key
    end  
  elseif last_branch_key then 
    last_branch[last_branch_key] = nil
  elseif first_key then
    last_branch[first_key] = nil
  end 
   
  if tb[key] and type(tb[key]) == "table"  then  
    
    table.insert(res_tb,key)
        
    local branch_keys = getKeys(tb[key])  
    if #branch_keys > 1 then
      last_branch = tb[key]
    end    

    return getRandBranch (tb[key], res_tb, last_branch, last_branch_key, first_key)    
  end
 
  return res_tb, last_branch_key
end


function GetRandBranchSiblings (tb, res_tb, unexplored, first_key)

  local keys = getKeys(tb)
  local rn
  
  local key, node = nil,nil
  
  if #keys > 0 then  
    rn = math.random(#keys)
    key = keys[rn]               
    
    if first_key and #keys > 1 then
      for _,v in ipairs(keys) do       
        if v ~= key then           
                  
          local tb2 = {}
          tb2[v] = tb[v]
          table.insert(unexplored,tb2)
        end
      end  
    end    
    
    if first_key == nil then
      first_key = key
    end 
  elseif #keys == 0 then

    for i=#unexplored,1,-1 do
      GetRandBranchSiblings (unexplored[i], res_tb, {}, first_key) 
    end
    
    return res_tb, first_key
  end 
   
  if tb[key] and type(tb[key]) == "table"  then      
    table.insert(res_tb,key) 
    return GetRandBranchSiblings (tb[key], res_tb, unexplored, first_key)    
  end
 
  return res_tb, first_key
end


function flatenBranches (tb)
  local flat_tb = {} 

  while lenTb(tb) > 0 do
    local res_tb = getRandBranch (tb,{},{},nil,nil) 
    table.insert(flat_tb,res_tb) 
  end
  
  return flat_tb 
end


local function treeP (tb) ----------------------------------------- PST --------------------------
  if type(tb) == "table" then 
    for k,v in pairs(tb) do 
      if type(v) == "table" then           
        
        if v.p < self.PST_minp then
          print ( v.p )
        else 
          treeP(v)  
        end          
      end      
    end    
  end
end


local function pruneTree (tb,tb2,minp)
  if type(tb) == "table" then 
    for k,v in pairs(tb) do 
      if type(v) == "table" then           
        
        if v.p > minp then
          tb2[k] = v  
          pruneTree(v,tb2[k],minp)  
        end          
      end      
    end    
  end
end


local function PSTAddP (tb)
  if type(tb) == "table" then
    local len = 0       
    for k,v in pairs(tb) do 
     
      if type(v) == "table" then    
        len = len + v.count
      end   
    end      
    
    for k,v in pairs(tb) do 
      if type(v) == "table" then    
        v.p = v.count / len          
      end
      PSTAddP(v)
    end    
  end
end


local function buildPST (tb, keys)
  
  local key = next(keys)
   
  if key == nil then 
    return     
  elseif tb[keys[key]] == nil then
    local key2 = keys[key]
    tb[key2] = {}
    tb[key2].count = 1    

    keys[key] = nil    
    buildPST (tb[key2], keys)
  elseif tb[keys[key]] then
    local key2 = keys[key]

    tb[key2].count = tb[keys[key]].count + 1    
  
    keys[key] = nil
    buildPST (tb[key2] , keys)
  end  
end


local function rootNotes (tb)
  local ret_tb = {}
  if type(tb) == "table" then 
    for k,v in pairs(tb) do 
      if (type(v) == "table" and k ~= 'p' and k ~= 'count') then    
        table.insert(ret_tb, k)                
      end
    end    
  end
  return ret_tb
end


function Markov:buildNotesTreePST() 
   
  local nn = self.PST_l
  local order = self.order - 1
  
  if self.mul and self.PST_l > 1 then
    nn = 1
  end

  for _,one_NS in ipairs(Stats.note_strings) do  
    for len=nn,self.PST_l do
      for i=1,#one_NS do                      
        local motif = {unpack(one_NS,i,i+len+order)}     
 
        if order > 0 then
          local head = reduce({unpack(motif, 1, self.order)}, function (ns1,ns2) return ns1 .. '|' .. ns2 end) 
          motif = cons({unpack(motif, self.order+1, #motif)}, head)  
        end
        
        if #motif == self.PST_l+1 then buildPST (self.chain, motif) end   
      end   
    end
  end  
  
  PSTAddP (self.chain) 
   
  local markov_pruned = {}  
  pruneTree (self.chain, markov_pruned, self.PST_minp) 

  self.chain = markov_pruned
end


function IterIP (tb,order,IP_iter) 
  local i = 0
  local j = 0
  local new_iter = false
  local node_counter = 0 
  
  local o = {}
  
  function o.inc()
    node_counter = node_counter + 1
  end
   
  function o.reset()
    node_counter = 0
  end
  
  function o.node_count()
    return node_counter
  end
  
  function o.iteration_no ()
    return j
  end   
    
  function o.next(depth) 
    if i == #tb and (j < IP_iter or IP_iter == 0) then
      i=0
      j=j+1
      new_iter = true
    else
      new_iter = false
    end
    
    i = i + 1
    
    local en = i
    local gram
     
    if depth == 0 then
      en = i + order - 1 
    end 
    
    if depth == 0 and i == #tb and order > 1 then
      local extend = #tb % order
      local tb1 = { unpack(tb,i,en) }
      local tb2 = { unpack(tb,1,order-1) }
      
      gram = table.concat(tableConcatRetNew( tb1,tb2), '|')
      i = order-1
      new_iter = true
    else 
      gram = table.concat({ unpack(tb,i,en) }, '|')
    end

    if gram then
      return gram,new_iter      
    else
      return nil,nil  
    end 
  end
  
  function o.keep_going()
    if i <= #tb and (j < IP_iter or IP_iter == 0) then
      return true 
    else
      return false  
    end     
  end
  
  return o
end


function nodeIP (tb,fun,depth,max_depth)  
  local val,new_iter = fun.next(depth)
  
  if new_iter then  
    sprint('Building notes dictionary, IP iteration ' .. fun.iteration_no() .. '  added ' .. fun.node_count() .. ' nodes')
    if fun.node_count() == 0 then
      return false
    end   
    fun.reset() 
  end

  if val and (depth <= max_depth or max_depth == 0) then
    if tb[val] == nil then

      tb[val] = {}     
      fun.inc()
      return true
    else            
      depth = depth + 1
      return nodeIP (tb[val],fun,depth,max_depth)    
    end
  else 
    return false
  end
end


local function nodesToNotesIP (tb,ns_tb)  
  if type(tb) == "table" then 
    
    local keys = {}
    
    for k,v in pairs(tb) do 
      if type(v) == "table"  then    
        table.insert(keys, k)                
      end      
    end  
    
    if #keys > 0 then
      local ix = math.random(#keys)    
      table.insert(ns_tb, keys[ix])  
      
      nodesToNotesIP(tb[keys[ix]],ns_tb)  
    end
  end
end


local function nodesToNotesIP2 (tb,res)  
  if type(tb) == "table" then 
    
    local keys = {}
    
    for k,v in pairs(tb) do 
      if type(v) == "table"  then    
        table.insert(keys, k)                
      end      
    end  
    
    if #keys > 0 then
      local ix = math.random(#keys)    
      table.insert(res, keys[ix])  
      
      return nodesToNotesIP2(tb[keys[ix]],res)  
    end
  end
  return res
end


function Markov:buildNotesTreeIP()   
  self.chain = {}
  
  for _,one_NS in ipairs (self.ns) do  
    local fun = IterIP (one_NS, self.order, self.IP_iter) 
  
    while fun.keep_going() do
      local new_nodes = nodeIP (self.chain ,fun, 0, self.IP_max_depth) 
      
      if not new_nodes then 
        sprint('No new nodes found in new IP iteration, exiting at ' .. fun.iteration_no())
        break 
      end
    end 
  end     
end


local function remEmptyIP (tb)
  if type(tb) == "table" then 
    for k,v in pairs(tb) do 
      if next(v) == nil  then    
        tb[k] = nil                
      end
    end    
  end
end


local function seachTbForKeys (tb,key_tb)
  
  if type(tb) == "table"  then
  
    for k,v in pairs(tb) do 
      if type(v) == "table" then  
               
        local key = head(key_tb) 
        
        if v[key] and #key_tb == 1 then         
          return v[key]   
        elseif v[key] then  
          return seachTbForKeys(v,tail(key_tb))  
        else
          return seachTbForKeys(v,key_tb)
        end                 
      end      
    end    
  end 
end


local function nstrToChrdNotes(ns) --------------------- N to STR and back -----------------------------
  local tb = splitDl (ns, ',')  
    
  local chrd = splitDl (tb[1], '_')   
  local len = tonumber(tb[2])  

   return map(chrd,function(v) return tonumber(v) end), len  
end


local function nstrToNote (ns) 
  local tb = splitDl (ns, ',')
  
  local len  = tonumber(tb[2]) 
  local note = tonumber(tb[1]) 

  local nn, oct = oct0 (note) 
  return nn, oct, len
end


local function startNtb (rootnotes, event_type) 

  local tb = {'Random'}
  
  for _,v in ipairs(rootnotes) do  
      
    local tb2  = splitDl (v, '|')
    local str = ''
    for k,vv in ipairs(tb2) do
      local evs = splitDl (vv, ',')[1]  
      
      local ns = map(splitPunRetNum(evs), function(v) return num2note(v) end)
      str = str .. table.concat(ns,' ') 
      
      if k<#tb2 then
        str = str .. ' | '
      end   
    end 
     
    table.insert(tb,str) 
  end 
    
  UI.markov_first_N.items = tb   
end

    
function Markov:addToBuf (ns,ns_tb)
  if #ns_tb > 0 then 
    
    local len = #self.buf
    
    if len > 10 then
      self.buf = {unpack(self.buf,len - 9, len)}  
    end
    
    each(splitDl (ns, '|'), function (ns) table.insert(self.buf,ns) end)
    each(ns_tb, function (ns) table.insert(self.buf,ns) end)
  end
end


function Markov:getLastBufN ()
  if #self.buf >= self.order then    
    return reduce( {unpack(self.buf, #self.buf-self.order+1, #self.buf)}, function(ns1,ns2) return ns1 .. '|' .. ns2 end)
  end
end
        

function Markov:branchToNotes (ns)
  
  local ns2
  local tb2 = {}
  
  if self.order > 1 then   
    ns2 = splitDl (ns, '|') 
    
    if self.typ == 'IP' then ns = ns2[1] end 
  else
    ns2 = ns 
  end
   
  if self.chain[ns] then    
    self.last_ns = ns        
    return nodesToNotesIP2 (self.chain[ns],{})  
  end


  local tb = copy(self.chain)

  while lenTb(tb) > 0 do 
    local branch = getRandBranch (tb,{},{},nil,nil) 
      
    if #branch > 0 then  
      tb2 = tablesCompRet (ns2,branch)
        
      if #tb2>0 then 
        return tb2 
      else
        tb2 = {}  
      end   
    end   
  end   
        
                                 
  if #tb2 == 0 then  
    ns = randomKey(self.chain)
    
    local i = 10 
    while ns == self.last_ns do 
      if i<0 then break end
      ns = randomKey(self.chain)
      i=i-1
    end     
    self.last_ns = ns        
    
    return nodesToNotesIP2 (self.chain[ns],{})   
  end
end


function Markov:Event (v,line,i) -- print('Event ' .. v .. '  i ' .. i)

  local start_ln
  if MW.block_editing then
   local _
    _, _, start_ln = getPatFun(MW.block_editing, renoise.song().selected_pattern_index)  
    start_ln = start_ln + 1
  else
    start_ln = 1
  end  
    
  local o = self.dst
   
  local len,note,oct,ch_notes = 0  
      
  if self.event_type == 2 then  

    local funLine = function()
      local line_poly = {0,0,0,0,0,0,0,0,0,0,0,0}     
     
      for col=1,12 do
        local last = #o[col].off
        if last > 0 then
          line_poly[col] = sumTb(o[col].len) + o[col].off[last]  
        end  
      end
      return math.max(unpack(line_poly)) 
    end
        
        
    if self.poly_ev.sub_notes and self.poly_ev.sub_notes[v] then
             
      local rix     = math.random(#self.poly_ev.sub_notes[v])
      local subn    = self.poly_ev.sub_notes[v][rix]
      local add_sub = {0,0,0,0,0,0,0,0,0,0,0,0} 
      
      if #subn > 1 then 
        local sub_line = {0,0,0,0,0,0,0,0,0,0,0,0} 
        
        for _,v in ipairs(subn) do      
          local last = #o[v.col].off
          
            if last > 0 then
              sub_line[v.col] = sumTb(o[v.col].len) + o[v.col].off[last]  
            end
        end
        local max_sub_line = math.max(unpack(sub_line)) 
        
        for _,v in ipairs(subn) do           
          local last = #o[v.col].len
          
            if last > 0 then 
              add_sub[v.col] = max_sub_line - sumTb(o[v.col].len)  
            else
              add_sub[v.col] = max_sub_line
            end   
        end
      end
      
      
      local lens = {}     
      for _,v in ipairs(subn) do 
        table.insert(lens,v.ln + v.dur)
      end
      
      local max_len = math.max(unpack(lens))  
      
      local len       
      if self.poly_ev.sub_notes.i == 1 then
        len = v.ln
        self.poly_ev.sub_notes.i = self.poly_ev.sub_notes.i + 1
      elseif self.poly_ev.sub_notes.i <= #subn then
        local ii = self.poly_ev.sub_notes.i
        len = subn[ii].ln - subn[ii-1].ln
        
        self.poly_ev.sub_notes.i = ii + 1
      end
      
      if len == nil or max_len >= self.poly_dur then
        self.poly_ev = nil 
        return funLine()
      end
        
      for _,v in ipairs(subn) do
        local j = self.i[v.col] 
        
        local len2    = self.poly_sub_len[v.col] + len  + add_sub[v.col]
        local nn, oct = oct0(v.note)
        
        o[v.col].vel[j]  = 128
        o[v.col].off[j]  = v.dur
        o[v.col].oct[j]  = oct       
        o[v.col].len[j]  = len2
        o[v.col].note[j] = nn             
        
        self.i[v.col] = self.i[v.col] + 1
      end
      
      return funLine()   
    end
  
    local ev = Scan.markow_poly[v]
    
    local count, rix = 0         
    for k,v in ipairs(ev.notes) do
      if v.sub_notes then
        local len = lenTb(v.sub_notes)
        if len > count then 
          rix   = k
          count = len
        end
      end
    end
    if count == 0 then
      rix = math.random(#ev.notes)
    end
    
    for _,v in ipairs(ev.notes[rix]) do 
    
      local j = self.i[v.col]    
      
      local len = 1 
      if self.poly_add[v.col] > 0 then
        len = len + self.poly_add[v.col]-1
      end
      
      self.poly_len[v.col] = self.poly_len[v.col] + len
      
      if i == 1 then 
        len                  = start_ln 
        self.poly_len[v.col] = start_ln
      end 
      
      local nn, oct = oct0(v.note)
      
      o[v.col].vel[j]  = 128 
      o[v.col].off[j]  = v.dur
      o[v.col].oct[j]  = oct       
      o[v.col].len[j]  = len 
      o[v.col].note[j] = nn         
      
      self.i[v.col] = self.i[v.col] + 1
    end  
        
    
    if ev.notes[rix].sub_notes then
      self.poly_ev             = ev.notes[rix]      
      self.poly_dur            = ev.max_dur
      self.poly_ev.sub_notes.i = 1
      
      self.poly_sub_len = copy(self.poly_len)
    else
      self.poly_ev = nil      
    end  
   
    self.poly_add   = {1,1,1,1,1,1,1,1,1,1,1,1}  

    line = funLine()
    
    for col=1,12 do  
      local last = #o[col].len
      if last > 0 then 
        self.poly_add[col] = line - sumTb(o[col].len)  
      else
        self.poly_add[col] = line
      end    
    end 
 
  elseif self.event_type == 3 then  
  
    ch_notes, len = nstrToChrdNotes(v)  
    
    if i == 1 then o.len[1] = start_ln end 
    
    o.vel[i]   = 128
    o.off[i]   = len
    o.len[i+1] = len
    o.notes[i] = ch_notes   
     
  elseif self.event_type == 1 then 
  
    note, oct, len = nstrToNote(v)                         
       
    if i == 1 then o.len[1] = start_ln end 
    
    o.vel[i]   = 128
    o.oct[i]   = oct
    o.off[i]   = len
    o.note[i]  = note
    o.len[i+1] = len                
  end
  
  return line + len  
end


function Markov:fill(note_col)

  if self.event_type == 3 then         
  
    fillPtr(note_col, CHptr, 3)     
      
  elseif self.event_type == 2 then
    local start_ln  
    
    if MW.block_editing then
      local _
      _, _, start_ln = getPatFun(MW.block_editing, renoise.song().selected_pattern_index)  
      start_ln = start_ln + 1
    else
      start_ln = 1
    end  
  
    fillPtr(note_col, Nptr, 2, {line_off = start_ln})     
  else    
    fillPtr(note_col, Nptr, 1)
  end
end


function Markov:Init() 
  init()
  
  if self.event_type == 2 then  
    emptyTr()
      
    self.i           = {1,1,1,1,1,1,1,1,1,1,1,1}
    self.poly_ev     = nil      
    self.poly_add    = {0,0,0,0,0,0,0,0,0,0,0,0}
    self.poly_len    = {1,1,1,1,1,1,1,1,1,1,1,1} 
    Markov.poly_durs = {0,0,0,0,0,0,0,0,0,0,0,0} 
  end
  
  if self.event_type == 3 then    
    self.dst = CHptr
  elseif self.event_type == 2 then
    self.dst = POLYptr
  else             
    self.dst = Nptr  
  end
end
    
      
function Markov:PST_IP_Run(...) 
  
  local ph = MW.phr.no
  
  local msg = '' 
  local key              
  
  self.i = {1,1,1,1,1,1,1,1,1,1,1,1}
                               
  if self.typ == 'PST' then    
    msg = 'PST - Did not generate any notes. Try decreasing PST L or PST R or increasing PST P '
  elseif self.typ == 'IP' then
    msg = 'IP - Not enough notes to pharse'
  end
  
  if #self.rootnotes < 1 then 
    sprint (msg) 
    return 
  else      
     -- self:grabNotes(false)  
    self:Init()
    startNtb (self.rootnotes, self.event_type)
  end

    
  local i = 1
  local line = 1 

  if self.first_n_ix then
    key = self.rootnotes[self.first_n_ix]   
    sprint('Start note ' .. key)  
    
    for _,ns in ipairs(splitDl(key,'|')) do
      line = self:Event(ns,line,i)
      i=i+1
    end
  else
    key = self.rootnotes[math.random(#self.rootnotes)]  
  end
           
  local root_branch = self.chain[key]      
  while line <= self.pat_len do   
  
    local ns_tb
        
    if arg[1] then 
      ns_tb = arg[1]
      arg[1] = nil
    else
      ns_tb = self:branchToNotes (key) 
    end

    Markov:addToBuf (key,ns_tb) 
        
    for k,ns in pairs(ns_tb) do  
     
      line = self:Event(ns,line,i)
      
      if line > self.pat_len then break end
   
      key = Markov:getLastBufN () 
              
      if self.chain[key] then
        if key == ns_tb[1] then
          key = randomKey(self.chain)
        end
      end      

      i=i+1    
    end          
  end    
  
  if self.event_type == 2 then
    for i=1,12 do
      assignNoteTbs(i)
      self:fill(i)      
    end
  else 
    self:fill(MW.phr.col)
  end
  
 -- if MW.block_editing then self:grabNotes(true) end 
  
  updateSlots() 
end
 

function Markov:PST_IP_Build()

  self.chain, self.rootnotes, self.buf = {},{},{}
  
  if self.typ == 'PST' then  
    self:buildNotesTreePST() 
  elseif self.typ == 'IP' then
    self:buildNotesTreeIP()
  end  
    
  remEmptyIP (self.chain)  
  self.rootnotes = rootNotes(self.chain) 
  
  self.chain2 = copy(self.chain)   
end


function Markov:buildMPLchain(L) --------------------------------- MLP

  local order = self.order - 1 

  for _,one_NS in ipairs(self.ns) do  
    for i=1,#one_NS do      

      local N_r, motif
    
      local tb = {unpack(one_NS, i, i+order)}
      local tb2  = {unpack(one_NS, i+self.order, i+order+L)}

      if #tb == self.order and #tb2 == L then 
        N_r  = reduce(tb, function (ns1,ns2) return ns1 .. '|' .. ns2 end) 
        motif = reduce(tb2, function (ns1,ns2) return ns1 .. '|' .. ns2 end)
    
        if self.chain [N_r] == nil then
          self.chain [N_r] =  {}        
        
          self.rootnotes[N_r] =  {}
          self.rootnotes [N_r].count =  1
        elseif self.rootnotes [N_r] then
          self.rootnotes [N_r].count =  self.rootnotes [N_r].count + 1
        end  
      
        if self.chain [N_r] [motif] == nil then
          self.chain [N_r] [motif] = {}
          self.chain [N_r][motif] =  {count = 1}  
        else
          local n = self.chain [N_r] [motif].count
          self.chain [N_r] [motif].count = n + 1
        end
      end
    end  
  end  
end


function Markov:branchToNotesMLP(ns)  
   
  local tb2 = {}  
   
  if self.chain[ns] then 
    self.last_ns = ns 
    
    return splitDl (randomKey(self.chain[ns]), '|')  
  end   
   
  local markov_tb = copy(self.chain)   
  local ns2
  
  while lenTb(markov_tb) > 0 do 

    ns2 = randomKey(markov_tb) 
    
    local tmp = markov_tb[ns2]   
    local branch = splitDl (randomKey(tmp), '|')  
    markov_tb[ns2] = nil    
      
    if #branch > 0 then  
      if self.order > 1 then    
        ns2 = splitDl(ns2, '|')     
      end

      tb2 = tablesCompRet (ns2 ,branch)  
       
      if #tb2>0 then return tb2 end       
    end   
  end   
        
                                 
  if #tb2 == 0 then 
    ns = randomKey(self.chain)
    
    local i = 10 
    while ns == self.last_ns do  
      if i<0 then break end
      ns = randomKey(self.chain)
      i=i-1
    end
    self.last_ns = ns 
    
    return splitDl (randomKey(self.chain[ns]), '|')    
  end
end


function Markov:MLP_Run(...) 

  local n_col = MW.phr.col 

  local notes = {}  
  for k,v in pairs(self.chain) do        
    table.insert(notes,k)  
  end
  
  if #notes < 1  then 
    sprint('MPL not enough notes')  
    return 
  else
   --   self:grabNotes(false)
    
    self:Init()   
    startNtb (notes, self.event_type) 
  end
  
  local i = 1
  local line = 1 


  local key = notes[math.random(#notes)] 

  if self.first_n_ix then
    key = notes[self.first_n_ix]      
          
    for _,ns in ipairs(splitDl(key,'|')) do
      line = self:Event(ns,line,i)  
      i=i+1
    end   
    
    sprint('Start note ' .. key)
  end


  while line <= self.pat_len do

    if i > #Nptr.note then
      growSeqTbs(Nptr.len, Nptr.note, Nptr.off, Nptr.oct, Nptr.vel)
      growChrdTbs() 
    end 

    local tb = {}      
    local motif = self:branchToNotesMLP(key)  
    
    if arg[1] then 
      motif = arg[1]
      arg[1] = nil   
    end
      
    self:addToBuf (key,motif) 

    for k,v in ipairs(motif) do 
      line = self:Event(v,line,i) 
      i=i+1
    end
        
    key = self:getLastBufN () 
      
    if self.chain[key] then
      if key == motif[1] then
        key = randomKey(self.chain)
      end
    end

    if line > self.pat_len then break end        
  end  

  if self.event_type == 2 then 
    for i=1,12 do
      assignNoteTbs(i)         
      self:fill(i)      
    end  
  else 
    self:fill(n_col)
  end
  
 -- if MW.block_editing then self:grabNotes(true) end
  
  updateSlots()   
end


function Markov:MLP_Build() 

  self.chain, self.rootnotes, self.buf = {},{},{} 
  
  if self.mul and self.PST_l > 1 then  
    for i=1,self.PST_l do
      self:buildMPLchain(i)  
    end
  else
    self:buildMPLchain(self.PST_l)    
  end

  local total = 0
  for v in pairs(self.rootnotes) do
    total = total + self.rootnotes[v].count 
  end
  
  for v in pairs(self.rootnotes) do
    self.rootnotes[v].p = self.rootnotes[v].count / total
  end
  
  for v in pairs(self.chain) do
    for vv in pairs(self.chain[v]) do
      self.chain [v] [vv].p = self.chain [v] [vv].count / self.rootnotes[v].count
    end
  end
    
  for v in pairs(self.rootnotes) do
    if self.rootnotes[v].p < self.PST_minp then
      self.rootnotes[v] = nil
    end
  end  

  for v in pairs(self.chain) do
    for vv in pairs(self.chain[v]) do
      if self.chain [v][vv].p < self.PST_minp or self.chain [v][vv].count < self.PST_r then
        self.chain [v][vv] = nil
      end
    end
  end  

  for v in pairs(self.chain) do
    if not next(self.chain[v]) then
      self.chain[v] = nil
    end
  end     
  
  self.chain2 = copy(self.chain)  
end
 
 
function Markov:__init(pat_len, ns, etype, dst)  --  Markov(pat_len, Stats.note_strings, 1, Nptr) 
 
  self.ns        = ns       
  self.dst       = dst   
  self.pat_len   = pat_len  
  self.continue  = 1
  self.event_type = etype
  
  self.first_n_ix = nil  
end


function Markov:run()
  local params = self:paramsToStr()  
  
  --init(0)
  
  if string.find(self.params, params) == nil then  
    if self.typ == 'PST' or self.typ == 'IP' then
      self:PST_IP_Build()
      self:PST_IP_Run()
    else
      self:MLP_Build()
      self:MLP_Run()
    end
    
    self.params = params    
  else  
  
    if self.typ == 'PST' or self.typ == 'IP' then
      self:PST_IP_Run()
    else
      self:MLP_Run()
    end
  end    
end


function Markov:checkParams()   
  local params = Markov:paramsToStr() 

  if string.find(self.params, params) == nil  then 
    if self.typ == 'PST' or self.typ == 'IP' then
      self:PST_IP_Build()
    else
      self:MLP_Build()  
    end
    
    self.params = params
  end
end


function continueMarkov (n_tb)  

  if Scan.Markov_process then  
    Scan.Markov_process:checkParams()  
    
    if #Scan.Markov_process.ns == 0 or lenTb(Scan.Markov_process.chain2) == 0 then 
      sprint('Empty') 
      return
      --Scan.Markov_process:checkParams()  
    end 
  else 
    return   
  end
  
  local block_notes = copy(n_tb)

  for k,v in ipairs(n_tb) do  
    n_tb[k] = copy(map(v, function(a) return a%12 end))
    table.sort(n_tb[k])
    table.sort(block_notes[k])     
  end     print('n_tb') rprint(n_tb)

  local src_ns = table.concat(map(n_tb,function(v) return table.concat(v,'_') end), '|') 
  local scr_head 

  while Scan.Markov_process.chain2 do  
    local nodes ,first_node  = GetRandBranchSiblings (Scan.Markov_process.chain2,{},{},nil)    
    local node_norm_tb, node_ns_tb = {},{}
    
    if  Scan.Markov_process.typ == 'MLP' then
      for k,v in ipairs(nodes) do  
        each(splitDl(v,'|'), function(v) table.insert(node_ns_tb, v) end)
      end        
      nodes = node_ns_tb    
    end  

      for k,v in ipairs(nodes) do
        local node_ns = splitDl(splitDl(v,',')[1],'_') 

        node_ns = copy(map(node_ns,function(v) return tonumber(v)%12 end))    
        table.sort(node_ns)
        node_norm_tb[k] = table.concat(node_ns, '_')   
      end 

    if Scan.Markov_process.typ == 'PST' or Scan.Markov_process.typ == 'IP' then    
       
      for i=1,#node_norm_tb do
        local ns_head = table.concat({unpack(node_norm_tb, i, i+Scan.Markov_process.order-1)}, '|') 
        local ns_res = {unpack(nodes, i, #nodes)}     

        if src_ns == ns_head and #ns_res > #ns_head then 
          Scan.Markov_process:PST_IP_Run(ns_res) 
          return
        end           
      end                      
    elseif Scan.Markov_process.typ == 'MLP' then
    
      for i=1,#node_ns_tb do
        local ns_head = table.concat({unpack(node_norm_tb, i, i+Scan.Markov_process.order-1)}, '|')   
        local ns_tail = {unpack(node_ns_tb, i+Scan.Markov_process.order, #node_ns_tb)}      

        if src_ns == ns_head and #ns_tail > 0 then        
          ns_head = {unpack(node_ns_tb, i, i+Scan.Markov_process.order-1)} 
          Scan.Markov_process:MLP_Run( tableConcatRetNew(ns_head,ns_tail) )      
          return
        end 
      end       
    end

    if first_node then
      Scan.Markov_process.chain2[first_node] = nil
    else
      break
    end    
  end    
  sprint('Empty')
end


function grabBlockNLcontinueExact() 

  if Scan.Markov_process then  
    Scan.Markov_process:checkParams()  
    
    if #Scan.Markov_process.ns == 0 or lenTb(Scan.Markov_process.chain2) == 0 then 
      sprint('Empty')
      return 
    end 
  else 
    return   
  end
  
  local pat = curPattern ()  
  local sel = renoise.song().selection_in_pattern 

  local n_tb,ns_tb = {},{}
  
  for tr = sel.start_track, sel.end_track do
    for ln = sel.start_line, sel.end_line do
      local n_col_tb = {}
      
      for n_col = sel.start_column, sel.end_column do      
        if n_col <= 12 then
          local note = pat:track(tr):line(ln):note_column(n_col).note_value
         
          if (note < 120) then 
            table.insert(n_col_tb,note)            
          end
        end
      end
      
      if #n_col_tb > 0 then
        table.insert(n_tb, n_col_tb)
      end
    end    
  end 
  
  if #n_tb == 0 then return end  

  for i,n_row in ipairs(n_tb) do      
    ns_tb[i] = table.concat(n_row,'_') 
  end  

  local ns = table.concat({unpack(ns_tb,1,Scan.Markov_process.order)},'|')

  while Scan.Markov_process.chain2 do
    local nodes ,first_node  = GetRandBranchSiblings (Scan.Markov_process.chain2,{},{},nil) 
    local node_ns_tb = {}

    if  Scan.Markov_process.typ == 'MLP' then
      for k,v in ipairs(nodes) do  
        each(splitDl(v,'|'), function(v) table.insert(node_ns_tb, v) end)
      end 
      nodes = node_ns_tb       
    end 

    for i=1,#nodes do
      local ns_head = table.concat({unpack(nodes, i, i+Scan.Markov_process.order-1)}, '|')    
      local chain = {unpack(nodes, i, #nodes)} 
      
      ns_head = splitDl(ns_head,',')[1]
      
      if ns == ns_head then          
        if Scan.Markov_process.typ == 'PST' or Scan.Markov_process.typ == 'IP' then    
          Scan.Markov_process:PST_IP_Run(chain) 
          return
        elseif  Scan.Markov_process.typ == 'MLP' then   
          Scan.Markov_process:MLP_Run(chain)        
          return
        end
      end
    end

    if first_node then
      Scan.Markov_process.chain2[first_node] = nil
    else
      break
    end    
  end  
    
  sprint('Finished, empty')
end


function MarkovProcess()  

  local pat_len = renoise.song().selected_pattern.number_of_lines
  
  local markov_typ  
  if UI.markov_typ.value == 1 then
    markov_typ= 'MLP'
  elseif UI.markov_typ.value == 2 then
    markov_typ= 'PST'
  elseif UI.markov_typ.value == 3 then
    markov_typ = 'IP'
  end      
  
  if #Stats.note_strings == 0 then return end
  
  if Scan.Markov_process == nil then 
    
    init(0)
    
    if MW.phr.editor_chords then
      Scan.Markov_process = Markov(pat_len, Stats.note_strings, 3, CHptr)      
    elseif MW.phr.editor_poly then
      Scan.Markov_process = Markov(pat_len, Stats.note_strings, 2, POLYptr)      
    else             
      Scan.Markov_process = Markov(pat_len, Stats.note_strings, 1, Nptr)      
    end
    
    Scan.Markov_process.typ = markov_typ    
    Scan.Markov_process:run()
  else     
    
    Scan.Markov_process.typ = markov_typ
    Scan.Markov_process:run()
  end
  
  if #Stats.note_strings == 1 then
    sprint('Generate notes from ' ..  #Stats.note_strings .. ' phrase')
  else
    sprint('Generate notes from ' ..  #Stats.note_strings .. ' phrases')
  end    
end

