
local last_editor = ''

function ui_editor_row()  
  
  local vb = renoise.ViewBuilder()
  
  local editor_pu
  
  editor_pu = vb:popup {
    width = 85,
    value = UI.editor_ix,
    tooltip = "Editors to choose from: Poly - for more than one note, N for notes only;empty rows are skipped.",
    items = {'Step','Step N', 'Step Poly', 'Step Poly N', 'VB', 'VB Poly', 'Chords', 'Arpeggiator', 'Tonnetz'  },   
    notifier = function(new_index)       
            
      MW.stopTimer()
       
      local editor       = editor_pu.items [new_index]
      UI.editor_ix       = new_index
      MW.phr.editor_name = editor 
      
      if editor == "Step Poly" or editor == "Step Poly N" or editor == "VB Poly" then
        Lib.file_ext = ".seqs"
        
        MW.phr.event_type          = 2
        MW.phr.editor_poly         = true        
        MW.phr.editor_chords       = false  
                    
        MW.last_pattern_editor_typ = 'poly'
                    
      elseif editor == "Chords" or editor == "Arpeggiator" or editor == "Tonnetz" then
        Lib.file_ext = ".chrd"    
        
        MW.phr.event_type    = 3
        MW.phr.editor_poly   = false
        MW.phr.editor_chords = true            
        
        if editor == "Tonnetz" then
          MW.seq_length = 4  
        end             
      else       
        Lib.file_ext = ".seq" 
        
        MW.phr.event_type          = 1
        MW.phr.editor_poly         = false
        MW.phr.editor_chords       = false
        MW.last_pattern_editor_typ = 'mono'  
      
        MW.last_pattern_editor_typ = 'mono'
      end       
      
      
      if editor == "VB" or editor == "VB Poly" then 
        MW.editor_vb = true
      else
        MW.editor_vb = false
      end
      
      if editor == 'Step' or editor == 'Step N' or editor ==  'Step Poly' or editor == 'Step Poly N' then
        MW.phr.editor_pattern = true 
      else
        MW.phr.editor_pattern = false 
      end
                  
      if editor == "Step N" or editor == "Step Poly N" then
        MW.phr.editor_pattern_N = true
      else
        MW.phr.editor_pattern_N = false
      end 
      
      UI.note_bts = {}
      
      initFillPhr(true)
      
      if Lib.editor == 1 then  
        if Scan.scale_key_on then
          local ix 
          local scale = UI.scales_pu.value 
          local key = UI.keys_pu.value  
        
          if MW.phr.editor_poly == false and MW.phr.editor_chords == false then
            ix = 'mono'          
          elseif MW.phr.editor_poly then
            ix = 'poly' 
          elseif MW.phr.editor_chords then
            ix='chrd'
          end 
          Scan.files = remExt(Scan.db_scale_key[ix][scale][key].fn)
        else
          Scan.files = getFilesRemExt()
        end
       
        if editor == "Arpeggiator" then
          getArpFiles()       
        end      
      
        UI.lib_pu.items = Scan.files
              
      --elseif Lib.editor == 3 then
      
      end
      
      MW.setTimer()  
    end
  }   
          
  local block_sel_chb = vb:checkbox {
    value = false,
    tooltip = "Limit the use to block selection",
    notifier = function(value) 
      MW.block_editing = value          
    end
  } 
      
  local phrase_lpb_vb = vb:valuebox {
      min = 1,
      max = 128,
      width = 45,
      value = getPhaseLPB(),
      tooltip = "Set phrase LPB.",
      notifier = function(value)     
        
        local inst_no = renoise.song().selected_instrument_index
        
        if #renoise.song().instruments[inst_no].phrases > 0 then
          renoise.song().instruments[inst_no].phrases[MW.phr.no].lpb = value
        end
      end
    }
    
  local phrase_chb = vb:checkbox {
    value = false,   
    tooltip = "Use the Reoise phrase editor instead of the pattern editor.",
    notifier = function(value) 
      MW.edit_RN_phrase = value
      
      local inst_no = renoise.song().selected_instrument_index
      
      local scale_no = UI.scales_pu.value 
      
      if value then
             
        UI.scales_pu.items = renoise.song().instruments[inst_no].trigger_options.available_scale_modes
        
        renoise.song().instruments[inst_no].phrase_playback_mode = 2
        renoise.song().instruments[inst_no].phrase_program = 1        
         
        renoise.song().instruments[inst_no].trigger_options.scale_mode = UI.scales_pu.items[scale_no]          
      else             
        renoise.song().instruments[inst_no].phrase_playback_mode = 1
       
        UI.scales_pu.items = Scales.names
      end
    end
  }        
      
  local editor_row = vb:row { 
    style = 'group',    

    vb:text {
      width = 45,
      text = "   Editor"
    },
    editor_pu,
   
    vb:text {
      width = 35,
      text = "  Block"
    },           
    block_sel_chb,  
    
    vb:text {
      width = 15,
      text = " RN Phr"
    }, 
   
    phrase_chb,
   
    vb:text {
      width = 15,
      text = " LPB"
    },        
   phrase_lpb_vb,   
  }
  
  UI.editor_pu = editor_pu
   
  return editor_row       
end


