
------------------------------------- UI harmonize
    
function ui_harmonize()
  
  local vb = renoise.ViewBuilder()
  
  
  local harmonize_sw = vb:switch {
     width = 125,
     value = MW.harmonize_typ,
     tooltip = 'P>CH harmonize phrase to loaded chords, CH>P find chords to loaded phrase',
     items = {'OFF', 'P>CH', 'CH>P'},
     notifier = function(val)    
       MW.harmonize_typ = val
    end  
  }   
    
  local harmonize = vb:button {
    tooltip = "Harmonize selected track to loaded chords",
    text = " P>CH tr",
    notifier =  function ()       
      if not noteLengthEmpty(CHptr.len) and not noteLengthEmpty(Nptr.len) then 
        getChordPos(CHptr.len)  
       -- harmonizeP2Ch ()  
        harmonize (MW.harmonize_track)
      end
    end 
   } 
  
  local trackName = vb:text {
    width = 75,
    text = renoise.song().tracks[1].name
  } 
     
  local harmonize_vb  = vb:valuebox {
    min = 1,
    max = #renoise.song().tracks,
    value = 1,
    width = 50,
    notifier = function(value) 
      MW.harmonize_track = value
      trackName.text = renoise.song().tracks[value].name 
    end
  }     
    
  local harmonize_tr_chb = vb:checkbox {
    value = false,
    tooltip = "When 'P>CH' on, load chords to specified track, 'P>CH tr' force notes to chords on selected track",
    notifier = function(value) 
      MW.harmonize_fill_chrd = value          
    end
  }
  
  local harmonize_ins_vb = vb:valuebox {
    tooltip = "Chords instrument number",
    min = 0,
    max = #renoise.song().instruments,
    value = 0,
    width = 50,
    notifier = function(value) 
      MW.harmonize_inst = value
    end
  }  
  
  local harmonize_row = vb:row{
    style = 'group',
    harmonize_sw,
    
    harmonize,

    harmonize_vb,
    trackName,  
    vb:text {
      width = 20,
      text = "CH"
    },  
    harmonize_tr_chb,
    vb:text {
      width = 15,
      text = " i"
    }, 
    harmonize_ins_vb,
  }
  
  return harmonize_row
end

