
function write_update_lib_popup (name,ext)
  local filename = MW.path .. name .. ext  
  
  Save.notes(filename)
  
  UI.scan_sw.value = 1 
  
  Lib.suspend = true
  UI.lib_pu.items = remExt(os.filenames(MW.path, {"*" .. ext}))
  
  for i=1,#UI.lib_pu.items do
     if (name == UI.lib_pu.items[i]) then
       UI.lib_pu.value = i
     end
  end
  Lib.suspend = false
end        

function write_arp_lib_popup (name,ext)
  local filename = MW.path .. name .. ext  
  
  writeArpForms(filename)   

  UI.arplib_pu.items = remExt(os.filenames(MW.path, {"*" .. ext}))
  
  for i=1,#UI.arplib_pu.items do
     if (name == UI.arplib_pu.items[i]) then
       UI.arplib_pu.value = i
     end
  end
end 

--------------------------------------------------- UI library row

function ui_library()
  
  local library_pu 
  
  local vb = renoise.ViewBuilder()
  
  local ph = MW.phr.no
  local col = MW.phr.col
  
  library_pu = vb:popup {
      width = 160,
      value = Lib.last_sel,
      items = Scan.files,
      tooltip = "Saved presets",
      notifier = function(new_index)     
        
        if Lib.suspend then return end
        
        local filename 
        
        if Lib.editor == 2 then 
          filename = MW.path .. library_pu.items[new_index] .. '.phr'
        elseif Lib.editor == 1 then  
          filename = MW.path .. library_pu.items[new_index] .. Lib.file_ext 
        end
        
        MW.stopTimer()                  
                      
        if MW.edit_RN_phrase then
          local inst_no = renoise.song().selected_instrument_index
          
          if (renoise.song().instruments[inst_no].phrases[1] == nil) then
            renoise.song().instruments[inst_no]:insert_phrase_at(1)
          end
          
          renoise.song().instruments[inst_no].phrase_playback_mode = 2
          renoise.song().instruments[inst_no].phrase_program = 1  
        end    
        

        if Lib.editor == 2 then
        
          Load.notes(filename)   
          
          UI.phraseTbBuild()
          UI.phrase_no.max   = #MW.phr
          UI.phrase_no.value = MW.phr.no  
                          
          initFillPhr(false)    
          return 
        end
        
        if MW.phr.editor_name == "Step Poly" or MW.phr.editor_name == "Step Poly N" or MW.phr.editor_name == "VB Poly" then ---------------------
          local oct_lowest, oct_highest = 8,2
          
          initPoly()  
          Load.notes(filename)
                    
          for i=1,12 do  
            assignNoteTbs(i)  
            
            if Nptr.oct_lowest < oct_lowest then
              oct_lowest = Nptr.oct_lowest
            end
      
            if Nptr.oct_highest > oct_highest then
              oct_highest = Nptr.oct_highest
            end
               
            if MW.harmonize_typ == 2 and #Chords.pos > 0 and noteLengthEmpty(Nptr.len) == false then    
              harmonizeP2Ch()               
            end
                      
            fill(i)            
          end
          
          if MW.harmonize_typ == 3 then
             harmonizeCh2P(ScannerH())
          end
          
          assignNoteTbs(MW.phr.col)     
                    
          phraseScanner()
          
          UI.suspend_update = true
          UI.oct_st.value  = oct_lowest  
          UI.oct_end.value = oct_highest+1   
          UI.suspend_update = false
          
          updateSlots()      
          
        elseif MW.phr.editor_chords then --------------------------------- chord
          initChords()   

          Load.notes(filename)   
            
          getChordPos(CHptr.len) 
          
          if MW.harmonize_typ == 2 then
          
            if not noteLengthEmpty(Nptr.len) then 
               
              if MW.last_pattern_editor_typ == 'mono' then  
            
                assignNoteTbs(MW.phr.col)            
                harmonizeP2Ch()                         
                phraseScanner()
                fillPtr(MW.phr.col, Nptr, 1) 
              
              elseif MW.last_pattern_editor_typ == 'poly' then  
            
                for i=1,12 do  
                  assignNoteTbs(i)                  
                  harmonizeP2Ch()      
                  fillPtr(i, Nptr, 1)            
                end                 
              end
            else 
              duplicateChordNotes()
            end
            
            if MW.harmonize_fill_chrd then
              fillPtr(MW.phr.col, CHptr, 3, {track = MW.harmonize_track, inst = MW.harmonize_inst})
            end
           
          else          
            if MW.harmonize_typ == 3 then  
              harmonizeCh2P(ScannerChordH())  
            end
         
            if MW.phr.editor_name == "Tonnetz" then
              MW.seq_length = 4
              --UI.slots_end.value = 4         
            end  
            
            fill(MW.phr.col) 
            phraseScanner()            
            updateSlots()    
            duplicateChordNotes()    
          end          
          
        else  ----------------------------------------- mono
                     
          initNotes()     
          Load.notes(filename)    
                 
          if Lib.mutate then
            mutateFun()  
          end
          
          if MW.harmonize_typ == 2 then 
            harmonizeP2Ch()   
          elseif MW.harmonize_typ == 3 then   
            harmonizeCh2P(ScannerH())        
          end
            
          phraseScanner()  
          
          UI.suspend_update = true
          UI.oct_st.value   = Nptr.oct_lowest
          UI.oct_end.value  = Nptr.oct_highest+1
          UI.suspend_update = false
          
          fill(MW.phr.col)
          updateSlots()   
          duplicateNotes()                   
        end
                        
        if WeightedIntervals.lock == 1 then
          duplicateNotesRand()
          WeightedIntervals.new = true
        end
  
        Lib.last_sel = new_index 
        
        findScaleKeyUpdatePopup()
        
        if Scales.auto_sel then
          UI.funSel()
        end
        
        --Stats.note_strings = {}
        
        MW.setTimer()
      end
  } 
    

  local lib_save_but = vb:button {
      text = " Save ",
      tooltip = "Store preset",
      notifier =  function ()  
      local name = library_pu.items [library_pu.value]
            
        if Lib.editor == 2 then 
          SavePresetPrompt(name, '.phr', write_update_lib_popup, library_pu.items)
        else 
          SavePresetPrompt(name, Lib.file_ext, write_update_lib_popup, getFilesRemExt())--library_pu) 
        end
      end 
    } 
 
  local lib_save_inc_but = vb:button {
    text = " + ",
    tooltip = "Add counter to the end of preset name or increase existing one and save.",
    notifier =  function () 
      local name = library_pu.items [library_pu.value]  
        
      if Lib.editor == 2 then 
        write_update_lib_popup(nameCounter (name, 1), '.phr') 
      elseif Lib.editor == 1 then
        write_update_lib_popup(nameCounter (name, 1), Lib.file_ext)
      end 
    end
  }   

  local lib_save_dec_but = vb:button {
    text = " - ",
    tooltip = "Add counter to the end of preset name or decrease existing one and save.",
    notifier =  function () 
      local name = library_pu.items [library_pu.value]      
      
      if Lib.editor == 2 then  
        write_update_lib_popup(nameCounter (name, -1), '.phr') 
      elseif Lib.editor == 1 then
        write_update_lib_popup(nameCounter (name, -1), Lib.file_ext) 
      end
    end 
  }         

  local lib_delete_but = vb:button {
      tooltip = "Delete preset from disk",
      text = " - ",
      notifier =  function ()          
        local name = library_pu.items [library_pu.value]
        os.remove (MW.path ..  name .. Lib.file_ext)   
        local files = remExt(os.filenames(MW.path, {"*" .. Lib.file_ext}))
           
        library_pu.items = files
      end 
    } 
    
  local lib_type_pu = vb:popup {
    width = 65,
    value = Lib.editor,
    items = {'Notes', 'Phrases'}, --, 'Markov'},
    tooltip = "Libraries: Notes / Phrases",
    notifier = function(nix)       
      Lib.editor = nix
     
      if nix ~= 3 then 
        Scan.files = getFilesRemExt()
        UI.lib_pu.items = Scan.files
      end  
    end
  }  
              
  
       
  local lib_row = vb:row {
      vb:row{
      spacing = 0,
      
      style = "group",
      vb:text {
          width = 20,
          text = "  Lib  "
      }, 
      lib_type_pu,
      library_pu,
      lib_save_but,
      lib_save_inc_but,
      lib_delete_but,      
    },  
         
  }    

  UI.lib_pu = library_pu
  return lib_row
end 

