
------------------------------------------------- UI note column / slots start. end    selection PU

function ui_note_col_oct()
  
  local vb = renoise.ViewBuilder()
  
  local note_col_vb = vb:valuebox {
    min = 1,
    max = 12,
    width = 45,
    value = MW.phr.col,
    tooltip = "Note column", 
    notifier = function(value)
      MW.phr.col = value
        
      if MW.phr.editor_poly then
        assignNoteTbs(value)
        updateSlots()
      end
    end
  }   
      
  local note_col_row = vb:row {
    vb:text {
      width = 30,
      text = " Col "
    },
    note_col_vb,  
  }  
  
  local start_vb = vb:valuebox {
    min = 1,
    max = 128,
    width = 50,
    tooltip =  "Beginning  row / note of the editor.",
    value = MW.seq_start,
    notifier = function(value)
      --renoise.tool():remove_timer(MW.timerFun)
      MW.seq_start = value
       
      if UI.suspend_update then return end
       
      updateSlots('slot')
      --renoise.tool():add_timer (MW.timerFun, MW.timer)
    end
  }
      
  local start_row = vb:row {    
    vb:text {
      width = 15,
      text = " Row "
    },
    start_vb,  
  }  
  
  local slots_vb = vb:valuebox {
    min = 1,
    max = 64,
    width = 50,
    tooltip = "Last row / note of the editor.",
    value = MW.seq_length,
    notifier = function(value)
     -- renoise.tool():remove_timer(MW.timerFun)
      MW.seq_length = value
        
      if UI.suspend_update then return end
        
      updateSlots('slot')
    --  renoise.tool():add_timer (MW.timerFun, MW.timer)
    end
  }
    
  local slots_row = vb:row {
    vb:text {
      width = 15,
      text = " to "
    },
    slots_vb,  
  }   
  
  local st_en_popup = vb:popup {
    width = 60,
    value = 1,
    tooltip = "Predefined pattern position and length to be displayed.",
    items = {"select", "all", "1 - 1/2", "2 - 1/2", "1 - 1/3", "2 - 1/3", "3 - 1/3", "1 - 1/4", "2 - 1/4", "3 - 1/4", "4 - 1/4", "block"}, 
    notifier =  function (val)      
        
      local pat_con, pat_len = getPatFun(MW.block_editing)       
      
      local half = round(pat_len/2)
      local third = round(pat_len/3)
      local fourth = round(pat_len/4)               
                  
      if val == 2 then
        start_vb.value = 1     
        slots_vb.value = pat_len        
      elseif val == 3 then  -- 1 - 1/2
        start_vb.value = 1   
        slots_vb.value = half           
      elseif val == 4 then  -- 2 - 1/2
        start_vb.value = half + 1 
        slots_vb.value = pat_len 
      elseif val == 5 then  -- 1 - 1/3
        start_vb.value = 1   
        slots_vb.value = third   
      elseif val == 6 then   -- 2 - 1/3
        start_vb.value = third + 1   
        slots_vb.value = 2*third 
      elseif val == 7 then -- 3 - 1/3
        start_vb.value = 2*third + 1   
        slots_vb.value = pat_len
      elseif val == 8 then -- 1 - 1/4
        start_vb.value = 1   
        slots_vb.value = fourth
      elseif val == 9 then -- 2 - 1/4
        start_vb.value = fourth + 1   
        slots_vb.value = 2*fourth    
      elseif val == 10 then -- 3 - 1/4
        start_vb.value = 2*fourth + 1   
        slots_vb.value = 3*fourth    
      elseif val == 11 then -- 4 - 1/4
        start_vb.value = 3*fourth + 1   
        slots_vb.value = pat_len   
      elseif val == 12 then  -- sel   
        local sel = renoise.song().selection_in_pattern
          
        if sel ~= nil then 
          local len = sel.end_line - sel.start_line
    
          if len >1 then
            start_vb.value = sel.start_line   
            slots_vb.value = sel.end_line      
          end
        end  
      end
    end      
  } 
    
  local octave_st_vb = vb:valuebox {
    min = 0,
    max = 8,
    width = 45,
    value = 3,
    tooltip = "Editor's lower octave.",
    notifier = function(value)
      if UI.suspend_update then return end
      updateSlots()
    end
  }
    
  local octave_end_vb = vb:valuebox {
    min = 2 ,
    max = 10,
    width = 45,
    value = 6,
    tooltip = "Editor's upper octave.",
    notifier = function(value)
      if UI.suspend_update then return end
        updateSlots()
    end
  }     
    
  local oct_row = vb:row {   
    vb:text {
      width = 20,
      text = "  Oct "
    },
    octave_st_vb,   

    vb:text {
    width = 20,
      text = " to "
    },
    octave_end_vb,
  }
        
  local note_col_row = vb:row { 
    style = 'group', 
    spacing = 6,    
    note_col_row,    
    start_row,    
    slots_row,  
    st_en_popup,
    oct_row,
  } 
  
  UI.n_col = note_col_vb
 
  UI.slots_st  = start_vb
  UI.slots_end = slots_vb
  
  UI.oct_st  = octave_st_vb
  UI.oct_end = octave_end_vb
 
  return note_col_row
end

