
------------------------------------------- UI repeat / transpose  

function ui_rptr()
  
  local vb = renoise.ViewBuilder()
  
  local rep_trans_row = vb:row{
    spacing = 3,
  }  
  
  local repeatValueBox = vb:valuebox {
    tooltip = "Duplicate and transpose specified nuber or rows x times.",
    min = 0,
    max = 127,
    value = 16,
    width = 45,
    notifier = function(value) 
      if  repeat_transpose_pu ~= 1 then
       repeatSeq() 
      end
    end
  }  
    

  local repeatTxValueBox = vb:valuebox {
    tooltip = "Repeat this number of times",
    min = 1,
    max = 16,
    value = 3,
    width = 45,
    notifier = function(value) 
      if repeat_transpose_pu ~= 1 then
        
        local n_col = MW.phr.col
      
        for i=1,#UI.repeat_tr_vb do  
          if UI.repeat_tr_vb[i] ~= nil then
            rep_trans_row:remove_child(UI.repeat_tr_vb[i])
          end 
        end
          
        UI.repeat_tr_vb = {}
          
        for i=1,value do
          if repeat_transpose_pu == 2 then
            rep_trans_row:add_child(make_vb(i)) 
          elseif repeat_transpose_pu == 3 then
            rep_trans_row:add_child(make_vb_tr(i)) 
          end
        end  
        
        if repeat_transpose_pu == 2 or repeat_transpose_pu == 3 then
          fillRestoreAll()
        end
            
        if repeat_transpose_pu == 2 then  
          --if MW.phr.editor_poly == false then fill(n_col) end                    
          repeatSeq() 
        elseif repeat_transpose_pu == 3 then
        
          if MW.phr.editor_poly then    
            for i=12,1,-1 do           
              assignNoteTbs(i)  
              fill(i)  
            end 
          else
            fill(n_col) 
          end
          
        end
      end
    end
  }

  local rep_tr_pu = vb:popup {
    tooltip = 'Repeat / transpose',
    width = 45,
    value = repeat_transpose_pu,
    items = {'NA','RP','TR'},   
    notifier = function(value)
      repeat_transpose_pu = value   
      
      if noteLengthEmpty (Nptr.len) then return end
      
      for i=1,#UI.repeat_tr_vb do 
        if UI.repeat_tr_vb[i] ~= nil then
          rep_trans_row:remove_child(UI.repeat_tr_vb[i])
        end 
      end

      UI.repeat_tr_vb = {}

      if value == 1 then        
        fillRestoreAll()
        
      elseif value == 2 then
        for i=1,repeatTxValueBox.value do
          rep_trans_row:add_child(make_vb(i))
        end     
           
        fillRestoreAll()
        
        repeatSeq()  
      elseif value == 3 then  
      
        for i=1,repeatTxValueBox.value do
          rep_trans_row:add_child(make_vb_tr(i))
        end   
        
        fillRestoreAll()              
      end      
    end
  }  
        
  local repeat_row = vb:column {
    style = 'group',
    margin = 5,  
    spacing = 3,
    vb:row{
      spacing = 3,
      margin = 0,  
      rep_tr_pu,
      repeatValueBox,
      vb:text {
          width = 10,
          text = "x"
      },  
      repeatTxValueBox,    
    }, 
    rep_trans_row,
  }
  
  UI.rplen_vb = repeatValueBox
  UI.rpn_vb = repeatTxValueBox
  return repeat_row
end

