

-------------------------------------- UI save preset prompt

local dialog_save

function SavePresetPrompt(patch_name, ext, fun, folder_items)

  local vb = renoise.ViewBuilder() 
  
  if dialog_save and dialog_save.visible then
     dialog_save:show()  
     return 
  end
   
  local filename = ""
  local label_tc = "    "
  
  if not patch_name then patch_name = '' end
  
  filename =  MW.path .. patch_name .. ext

  if fileExists(filename) then
    label_tc =  "File already exists, overwrite ?"  
  end
  
  local label = vb:text {
      text = label_tc
    }
  local field =  vb:textfield {
        width = 125,
        align = "center",
        text = patch_name,
        id = 'file_prompt',
        notifier = function(text)       
          
          filename =  MW.path .. text .. ext       
 
          if fileExists(filename) then
            label.text =  "File already exists, overwrite ?"  
          else
            label.text =  "  "
          end
        end
    }
    
  local but_ok = vb:button {
        text = "    OK    ",
        notifier =  function ()
          fun(field.text,ext)
          dialog_save:close()
        end 
       }
  local but_cancel = vb:button {
        text = "  Cancel  ",
        notifier =  function ()
          dialog_save:close() 
        end 
       }
              
  local dialog_content2 = vb:column { 
    margin = 15,
    spacing = 5,
    vb:text {
      text = "Enter preset name"
    },
    vb:row {
      field,
      vb:button {
        text = " + ",
        notifier =  function () 
          field.text = nameCounter (field.text, 1) 
        end 
       }, 
       vb:button {
        text = " - ",
        notifier =  function () 
          field.text = nameCounter (field.text, -1)  
        end 
       }, 
    }, 
    vb:row {
      vb:text {
      text = "Library  "
      },
      vb:popup {
        width = 100,
        value = 1,
        items = folder_items, --getFilesRemExt(),   
        notifier = function(new_index)  
          field.text = folder_items[new_index]        
        end
      },
    },   
    label,
    vb:row {
      but_ok,
      but_cancel,
    },
  }  
  
  dialog_save = renoise.app():show_custom_dialog("Save Preset", dialog_content2, function(dialog,key) return key end)
end

