
---------------------------------------------- SECOND ROW  -----  ui scales

function ui_scales ()
  
  local vb = renoise.ViewBuilder()

  local popup_scales = vb:popup {
    width = 150,
    value = 1,
    items = Scales.names,    
  }    
    
  local popup_keys = vb:popup {
    width = 45,
    value = 1,
    items = Scales.keys,    
  }      
 
 local scale_sw = vb:switch {
     width = 60,
     value = Scales.on,
     tooltip = "ON - grid displays notes that only belong to selected scale and key. OFF - scale notes are denoted with dots '.'",
     items = {"ON", "OFF"},
     notifier = function(val)    
       Scales.on = val
    end  
  }    
    
  local scales_row = vb:row {
    spacing = 5,
  
    vb:text {
      width = 30,
      text = "Scale "
    },
    popup_scales,
    scale_sw,
  }
 
  
  local update_bt = vb:button {
    tooltip = "Update notes and editor with selected scale and key",
    text = " Update ",
    notifier =  function ()
      if MW.edit_RN_phrase then
        local inst_no = renoise.song().selected_instrument_index
        
        renoise.song().instruments[inst_no].trigger_options.scaleKey = popup_keys.value
        
        local scales_rn = renoise.song().instruments[inst_no].trigger_options.available_scale_modes          
        renoise.song().instruments[inst_no].trigger_options.scale_mode = scales_rn[popup_scales.value]        
      else    
        if Scales.on == 1 then  
          UI.note_bts = {}
          
          if MW.phr.editor_chords then
            for i,notes in ipairs(CHptr.notes) do
              CHptr.notes[i] = map(notes, function(v) return noteInScale(v) end)          
            end
            fill(MW.phr.col)           
          elseif MW.phr.editor_poly then  
                            
            for i=1,12 do                   
              POLYptr.note = map(POLYptr[i].note, function(v) return noteInScale(v) end)  
              
              assignNoteTbs(i)                              
              fill(i)   
            end                                        
          else          
            Nptr.note = map(Nptr.note, function(v) return noteInScale(v) end)  
            fill(MW.phr.col)
          end              
        end         
        
        Stats.note_strings = {}
        
        phraseScanner()
        updateSlots()
      end      
    end 
  }       
  
  local funSel = function()
    if #Scales.best_scale > 0 and #Scales.best_key > 0 then      
      UI.scales_pu.value = Scales.best_scale[1]
      UI.keys_pu.value = Scales.best_key[1]
    end
  end
     
  local scale_sel = vb:button {
    tooltip = "Select first scale with most matching notes.",
    text = "Sel",
    notifier = funSel
   }  
    
  local auto_sel_chb = vb:checkbox {
      tooltip = 'Auto select scale and key.',
      value = Scales.auto_sel,
      notifier = function (val)
        Scales.auto_sel = val
        funSel()
      end
    }  

     
  local keys_row = vb:row {
    spacing = 3,
    vb:text {
      width = 25,
      text = "key"
    },
    popup_keys,
    
    update_bt,
    scale_sel,   
    vb:text {
      align = 'right',
      width = 25,
      text = 'Auto'
    }, 
      
    auto_sel_chb,
  }    
      
  local scales_col = vb:column {
    style = 'group',
    spacing = 3,
    margin = 5,
      scales_row,
      keys_row,  
  }
  
  
  UI.funSel   = funSel
  UI.scale_sw = scale_sw  
  
  UI.keys_pu   = popup_keys  
  UI.scales_pu = popup_scales
  
  return scales_col      
end 

