local setup_dialog

function SetupPrompt()

  local vb = renoise.ViewBuilder()
  
  if setup_dialog  and setup_dialog.visible then
     setup_dialog:show()  
     return 
  end

  local tx = vb:text {
    text = "Folder:  " .. MW.path
  }   
  
  local but_ok = vb:button {
    text = "    OK    ",
    notifier =  function ()
      if Lib.temp_path ~= nil and io.exists(Lib.temp_path) then
        preferences.path.value = Lib.temp_path
        MW.path = Lib.temp_path          
        setup_dialog:close()
      else
        sprint('No new valid folder selected')
        setup_dialog:close()
      end 
    end 
  }
       
  local but_cancel = vb:button {
    text = "  Cancel  ",
    notifier =  function ()
      setup_dialog:close() 
    end 
  }       

  local but_new_folder = vb:button {
    text = " Select New Folder ",
    notifier =  function ()
      Lib.temp_path = renoise.app():prompt_for_path("Select Library Folder")
      tx.text =  "Folder:  " .. Lib.temp_path
    end 
  } 
           
  
        
  

  local mutate_sw = vb:switch {
    width = 100,
    value = Rand.mutate_markov,
    tooltip = "mutate using simple randomization or Markov chain",
    items = {"Random", "Markov"},
    notifier = function(val)    
      Rand.mutate_markov = val
   end  
  }       
    
     
  
        
  local dialog_content = vb:column { 
    margin = 10,
    spacing = 6,    
   
        
    vb:text {
      width = 60,
      text = ' Lib mutate '
      },
    mutate_sw,

    
    tx,
    but_new_folder,       
    vb:row {
      but_ok,
      but_cancel,
    },
  }    

  setup_dialog = renoise.app():show_custom_dialog('Setup, Utilities', dialog_content, function(dialog,key) return key end)      
end

