
local function trNOrep(value, note_col)
   
  local pat_con, pat_len, line2 = getPatFun(MW.block_sel_tr)

  if MW.block_sel_tr == false then line2 = line2 - 1 end

  local line = -1
  
  for i=1,#Nptr.note  do
  
    line = line +  Nptr.len[i]  
    
    if line >= pat_len then fill(note_col) return end
    
    if line >= line2 and Nptr.len[i] > 0 then         
     Nptr.note[i],Nptr.oct[i] = transpose(value, Nptr.note[i] ,Nptr.oct[i])            
    end
  end
 fill(note_col)
end  


local function trNOrepChrd(value)
  
  local note_col = MW.phr.col
  
  local pat_con, pat_len, line2 = getPatFun(MW.block_sel_tr)

  if MW.block_sel_tr == false then line2 = line2 - 1 end

  local note     
  
  local line = -1
  
  for i,notes in ipairs(CHptr.notes)  do
  
    line = line +  CHptr.len[i]  
    
    if line >= pat_len then fill(note_col) return end
    
    if line >= line2 and CHptr.len[i] > 0  then         
      
      for k,note in ipairs(notes) do      
        local nn, oct = transpose(value, note%12, math.floor(note/12))
        notes[k] = nn + oct*12            
      end
    end
  end
 fill(note_col)
end  


local function trNOrepOct(value, note_col)
  
  local pat_con, pat_len, line2 = getPatFun(MW.block_sel_tr)
  
  if MW.block_sel_tr == false then line2 = line2 - 1 end
  
  local note  
  local line = -1
  
  for i=1,#Nptr.note  do
    
    line = line +  Nptr.len[i]
    
    if line > pat_len then break end
        
    if line >= line2 and ((value < 0 and Nptr.oct[i] > 0) or (value > 0 and Nptr.oct[i] < 9)) and Nptr.len[i] > 0 then

      Nptr.oct[i] = Nptr.oct[i]+value  
    end
  end  
    fill(note_col)  
end  


local function trNOrepOctChrd(value, note_col)
  
  local pat_con, pat_len, line2 = getPatFun(MW.block_sel_tr)
  
  if MW.block_sel_tr == false then line2 = line2 - 1 end
  
  local new_note  
  local line = -1
  
  for i,notes in ipairs (CHptr.notes)  do
    
    line = line +  CHptr.len[i]
    
    if line > pat_len then break end
    
    for k,note in ipairs(notes) do   
      local nn, oct = oct0(note)
        
      if line >= line2 and ((value < 0 and oct > 0) or (value > 0 and oct < 9)) and CHptr.len[i] > 0  then

        notes[k] = nn + (oct+value)*12  
      end
    end
  end  
    fill(note_col)  
end  


local function TransposeBut(val)
  local col = MW.phr.col
  
  if MW.phr.editor_chords then  
    trNOrepChrd(val)     
  elseif MW.phr.editor_poly then    
            
    for i=12,1,-1 do           
      assignNoteTbs(i)                        
      trNOrep(val,i)        
    end  

    assignNoteTbs(col)
  else
    trNOrep(val,col)
  end 
  
  updateSlots()
end


local function TransposeButOct(val)
  local note_col = MW.phr.col
  
  if MW.phr.editor_chords then
    trNOrepOctChrd(val,note_col) 
  elseif MW.phr.editor_poly then       
    for i=12,1,-1 do        
      assignNoteTbs(i)                     
      trNOrepOct(val,i)        
    end  
  else
    trNOrepOct(val,note_col)    
  end 
  updateSlots()
end


------------------------------------- UI transpose row       
       
function ui_transpose()
  
  local vb = renoise.ViewBuilder()
         
  local tr_block_chb = vb:checkbox {
    value = false,
    tooltip = "Limit the use to block selection",
    notifier = function(value) 
      MW.block_sel_tr = value          
    end
  }  
        
  local tr_row = vb:row {
    style = 'group',
    
    vb:text {
    width = 20,
    text = "  TR "
    },
      
    vb:button {
      tooltip = "Transpose down by half a tone",
      text = "-",
      notifier =  function () 
        TransposeBut(-1)
      end 
     }, 
     vb:button {
      tooltip = "Transpose up by half a tone",
      text = "+",
      notifier =  function () 
        TransposeBut(1)
      end 
     },      
    vb:button {
      tooltip = "Transpose down by 1 octave",
      text = "-12",
      notifier =  function () 
        TransposeButOct(-1)     
      end 
     }, 
     vb:button {
      tooltip = "Transpose up by 1 octave",
      text = "+12",
      notifier =  function () 
        TransposeButOct(1)
      end 
     }, 
     vb:text {
       width = 25,
       text = " Block"
     },
     tr_block_chb,
   }
  
  return tr_row
end    

